#!/usr/bin/env ruby

# Structure of the .json with item catalog:
# {
#     "nyphilharmonic181210": {
#         "title": "New York Philharmonic: Rachmaninoff",
#         "city": "New York",
#         "venue": "Lincoln Center",
#         "date":  "2017-12-10",
#         "genres": ["classical music"],
#         "price": 94.0
#     }
#     "beachboys190321": { ... },
#     ....
# }

require 'recombee_api_client'
include RecombeeApiClient

require 'json'

client = RecombeeClient.new('events-example', 'PbBaEVxx8ZOj0x3BhGtqfHyi8qQ8rm8rE1JBnSPoCnHwetzO3gjHer96YVAIa14G')

client.send(ResetDatabase.new)

client.send(AddItemProperty.new('title', 'string'))
client.send(AddItemProperty.new('city', 'string'))
client.send(AddItemProperty.new('venue', 'string'))
client.send(AddItemProperty.new('date', 'timestamp'))
client.send(AddItemProperty.new('genres', 'set'))
client.send(AddItemProperty.new('price', 'double'))

file = File.read('items.json')
requests = JSON.parse(file).map do |item_id, values|
  SetItemValues.new(item_id, values, :cascade_create => true)
end

br = Batch.new(requests)
puts client.send(br)